## com.growl
Class Growl

    java.lang.Object
      com.growl.Growl

    public class Growl

extends java.lang.Object

A class that encapsulates the "work" of talking to growl

Field Summary
`static java.lang.String` `GROWL_APP_ICON` Ticket key for the application icon.
`static java.lang.String` `GROWL_APP_NAME` Ticket key for the application name.
`static java.lang.String` `GROWL_APP_REGISTRATION` The name of the growl registration notification for DNC.
`static java.lang.String` `GROWL_NOTIFICATION` The name of the growl notification for DNC.
`static java.lang.String` `GROWL_NOTIFICATION_APP_ICON` Notification key for the application icon.
`static java.lang.String` `GROWL_NOTIFICATION_DESCRIPTION` Notification key for the description.
`static java.lang.String` `GROWL_NOTIFICATION_ICON` Notification key for the icon.
`static java.lang.String` `GROWL_NOTIFICATION_NAME` Notification key for the name.
`static java.lang.String` `GROWL_NOTIFICATION_STICKY` Notification key for the sticky flag.
`static java.lang.String` `GROWL_NOTIFICATION_TITLE` Notification key for the title.
`static java.lang.String` `GROWL_NOTIFICATIONS_ALL` Ticket key for all notifactions.
`static java.lang.String` `GROWL_NOTIFICATIONS_DEFAULT` Ticket key for the default notifactions.

Constructor Summary
`Growl(java.lang.String inAppName, com.apple.cocoa.foundation.NSData inImageData)` Convenience method to contruct a growl instance, defers to Growl(String inAppName, NSData inImageData, NSArray inAllNotes, NSArray inDefNotes, boolean registerNow) with empty arrays for your notifications.

`Growl(java.lang.String inAppName, com.apple.cocoa.foundation.NSData inImageData, com.apple.cocoa.foundation.NSArray inAllNotes, com.apple.cocoa.foundation.NSArray inDefNotes, boolean registerNow)`
Convenience method to contruct a growl instance, defers to Growl(String inAppName, NSData inImageData, NSArray inAllNotes, NSArray inDefNotes, boolean registerNow) with empty arrays for your notifications.

`Growl(java.lang.String inAppName, com.apple.cocoa.application.NSImage inImage)` Convenience method to contruct a growl instance, defers to Growl(String inAppName, NSData inImageData, NSArray inAllNotes, NSArray inDefNotes, boolean registerNow) with empty arrays for your notifications.
`Growl(java.lang.String inAppName, java.lang.String inImagePath)` Convenience method to contruct a growl instance, defers to Growl(String inAppName, NSData inImageData, NSArray inAllNotes, NSArray inDefNotes, boolean registerNow) with empty arrays for your notifications.
`Growl(java.lang.String inAppName, java.lang.String[] inAllNotes, java.lang.String[] inDefNotes)` Convenience method to contruct a growl instance, defers to Growl(String inAppName, NSData inImageData, NSArray inAllNotes, NSArray inDefNotes, boolean registerNow) with the arrays passed here and empty Data for the icon.

Method Summary
`com.apple.cocoa.foundation.NSArray` `allowedNotifications()` Accessor for the Array of allowed Notifications returned an NSArray
`java.lang.String` `applicationName()` Accessor for The currently set "Application" Name
`com.apple.cocoa.foundation.NSArray` `defaultNotifications()` Accessor for the Array of default Notifications returned as an NSArray

`void`

`notifyGrowlOf(java.lang.String inNotificationName, com.apple.cocoa.foundation.NSData inIconData, java.lang.String inTitle, java.lang.String inDescription, com.apple.cocoa.foundation.NSDictionary inExtraInfo)`
Convenience method that defers to notifyGrowlOf(String inNotificationName, NSData inIconData, String inTitle, String inDescription, NSDictionary inExtraInfo, boolean inSticky) This is primarily for compatibility with older code

`void`

`notifyGrowlOf(java.lang.String inNotificationName, com.apple.cocoa.foundation.NSData inIconData, java.lang.String inTitle, java.lang.String inDescription, com.apple.cocoa.foundation.NSDictionary inExtraInfo, boolean inSticky)`
The fun part is actually sending those notifications we worked so hard for so here we let growl know about things we think the user would like, and growl decides if that is the case.

`void` `notifyGrowlOf(java.lang.String inNotificationName, com.apple.cocoa.application.NSImage inImage, java.lang.String inTitle, java.lang.String inDescription, com.apple.cocoa.foundation.NSDictionary inExtraInfo)` Defers to notifyGrowlOf(String inNotificationName, NSData inIconData, String inTitle, String inDescription, NSDictionary inExtraInfo) with null passed for icon and extraInfo arguments
`void` `notifyGrowlOf(java.lang.String inNotificationName, java.lang.String inTitle, java.lang.String inDescription)` Convenienve method that defers to notifyGrowlOf(String inNotificationName, NSData inIconData, String inTitle, String inDescription, NSDictionary inExtraInfo) with null passed for icon and extraInfo arguments
`void` `notifyGrowlOf(java.lang.String inNotificationName, java.lang.String inTitle, java.lang.String inDescription, boolean inSticky)` Convenience method that defers to notifyGrowlOf(String inNotificationName, NSData inIconData, String inTitle, String inDescription, NSDictionary inExtraInfo, boolean inSticky) with null passed for icon and extraInfo arguments
`void` `notifyGrowlOf(java.lang.String inNotificationName, java.lang.String inImagePath, java.lang.String inTitle, java.lang.String inDescription)` Convenienve method that defers to notifyGrowlOf(String inNotificationName, NSData inIconData, String inTitle, String inDescription, NSDictionary inExtraInfo) with null passed for extraInfo
`boolean` `register()` Register all our notifications with Growl, this should only be called once.
`void` `setAllowedNotifications(com.apple.cocoa.foundation.NSArray inAllNotes)` Set the list of allowed Notifications
`void` `setAllowedNotifications(java.lang.String[] inAllNotes)` Set the list of allowed Notifications
`void` `setApplicationName(java.lang.String inAppName)` Sets The name of the Application talking to growl
`void` `setDefaultNotifications(com.apple.cocoa.foundation.NSArray inDefNotes)` Set the list of Default Notfiications
`void` `setDefaultNotifications(java.lang.String[] inDefNotes)` Set the list of Default Notfiications

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### GROWL_APP_REGISTRATION

    public static final java.lang.String GROWL_APP_REGISTRATION

  The name of the growl registration notification for DNC.

  See Also:
    Constant Field Values

### GROWL_APP_NAME

    public static final java.lang.String GROWL_APP_NAME

  Ticket key for the application name.

  See Also:
    Constant Field Values

### GROWL_APP_ICON

    public static final java.lang.String GROWL_APP_ICON

  Ticket key for the application icon.

  See Also:
    Constant Field Values

### GROWL_NOTIFICATIONS_DEFAULT

    public static final java.lang.String GROWL_NOTIFICATIONS_DEFAULT

  Ticket key for the default notifactions.

  See Also:
    Constant Field Values

### GROWL_NOTIFICATIONS_ALL

    public static final java.lang.String GROWL_NOTIFICATIONS_ALL

  Ticket key for all notifactions.

  See Also:
    Constant Field Values

### GROWL_NOTIFICATION

    public static final java.lang.String GROWL_NOTIFICATION

  The name of the growl notification for DNC.

  See Also:
    Constant Field Values

### GROWL_NOTIFICATION_NAME

    public static final java.lang.String GROWL_NOTIFICATION_NAME

  Notification key for the name.

  See Also:
    Constant Field Values

### GROWL_NOTIFICATION_TITLE

    public static final java.lang.String GROWL_NOTIFICATION_TITLE

  Notification key for the title.

  See Also:
    Constant Field Values

### GROWL_NOTIFICATION_DESCRIPTION

    public static final java.lang.String GROWL_NOTIFICATION_DESCRIPTION

  Notification key for the description.

  See Also:
    Constant Field Values

### GROWL_NOTIFICATION_ICON

    public static final java.lang.String GROWL_NOTIFICATION_ICON

  Notification key for the icon.

  See Also:
    Constant Field Values

### GROWL_NOTIFICATION_APP_ICON

    public static final java.lang.String GROWL_NOTIFICATION_APP_ICON

  Notification key for the application icon.

  See Also:
    Constant Field Values

### GROWL_NOTIFICATION_STICKY

    public static final java.lang.String GROWL_NOTIFICATION_STICKY

  Notification key for the sticky flag.

  See Also:
    Constant Field Values

Constructor Detail

### Growl

    public Growl(java.lang.String inAppName,
                 com.apple.cocoa.application.NSImage inImage)

  Convenience method to contruct a growl instance, defers to Growl(String inAppName, NSData inImageData, NSArray inAllNotes, NSArray inDefNotes, boolean registerNow) with empty arrays for your notifications.

  Parameters:
    `inAppName` - - The Name of your "application"
    `inImage` - - The NSImage Icon for your Application

### Growl

    public Growl(java.lang.String inAppName,
                 com.apple.cocoa.foundation.NSData inImageData)

  Convenience method to contruct a growl instance, defers to Growl(String inAppName, NSData inImageData, NSArray inAllNotes, NSArray inDefNotes, boolean registerNow) with empty arrays for your notifications.

  Parameters:
    `inAppName` - - The Name of your "Application"
    `inImageData` - - The NSData for your NSImage

### Growl

    public Growl(java.lang.String inAppName,
                 java.lang.String inImagePath)

  Convenience method to contruct a growl instance, defers to Growl(String inAppName, NSData inImageData, NSArray inAllNotes, NSArray inDefNotes, boolean registerNow) with empty arrays for your notifications.

  Parameters:
    `inAppName` - - The Name of your "Application"
    `inImagePath` - - The path to your icon

### Growl

    public Growl(java.lang.String inAppName,
                 java.lang.String[] inAllNotes,
                 java.lang.String[] inDefNotes)

  Convenience method to contruct a growl instance, defers to Growl(String inAppName, NSData inImageData, NSArray inAllNotes, NSArray inDefNotes, boolean registerNow) with the arrays passed here and empty Data for the icon.

  Parameters:
    `inAppName` - - The Name of your "Application"
    `inAllNotes` - - A String Array with the name of all your notifications
    `inDefNotes` - - A String Array with the na,es of the Notifications on by default

### Growl

    public Growl(java.lang.String inAppName,
                 com.apple.cocoa.foundation.NSData inImageData,
                 com.apple.cocoa.foundation.NSArray inAllNotes,
                 com.apple.cocoa.foundation.NSArray inDefNotes,
                 boolean registerNow)

  Convenience method to contruct a growl instance, defers to Growl(String inAppName, NSData inImageData, NSArray inAllNotes, NSArray inDefNotes, boolean registerNow) with empty arrays for your notifications.

  Parameters:
    `inAppName` - - The Name of your "Application"
    `inImageData` - - The Data of your "Application"'s icon
    `inAllNotes` - - The NSArray of Strings of all your Notifications
    `inDefNotes` - - The NSArray of Strings of your default Notifications
    `registerNow` - - Since we have all the necessary info we can go ahead and register

Method Detail

### register

    public boolean register()

  Register all our notifications with Growl, this should only be called once.

  Returns:
    `true`.

### notifyGrowlOf

    public void notifyGrowlOf(java.lang.String inNotificationName,
                              com.apple.cocoa.foundation.NSData inIconData,
                              java.lang.String inTitle,
                              java.lang.String inDescription,
                              com.apple.cocoa.foundation.NSDictionary inExtraInfo,
                              boolean inSticky)
                       throws java.lang.Exception

  The fun part is actually sending those notifications we worked so hard for so here we let growl know about things we think the user would like, and growl decides if that is the case.

  Parameters:
    `inNotificationName` - - The name of one of the notifications we told growl about.
    `inIconData` - - The NSData for the icon for this notification, can be null
    `inTitle` - - The Title of our Notification as Growl will show it
    `inDescription` - - The Description of our Notification as Growl will display it
    `inExtraInfo` - - Growl is flexible and allows Display Plugins to do as they please with thier own special keys and values, you may use them here. These may be ignored by either the user's preferences or the current Display Plugin. This can be null
    `inSticky` - - Whether the Growl notification should be sticky
  Throws:
    `java.lang.Exception` - When a notification is not known

### notifyGrowlOf

    public void notifyGrowlOf(java.lang.String inNotificationName,
                              com.apple.cocoa.foundation.NSData inIconData,
                              java.lang.String inTitle,
                              java.lang.String inDescription,
                              com.apple.cocoa.foundation.NSDictionary inExtraInfo)
                       throws java.lang.Exception

  Convenience method that defers to notifyGrowlOf(String inNotificationName, NSData inIconData, String inTitle, String inDescription, NSDictionary inExtraInfo, boolean inSticky) This is primarily for compatibility with older code

  Parameters:
    `inNotificationName` - - The name of one of the notifications we told growl about.
    `inIconData` - - The NSData for the icon for this notification, can be null
    `inTitle` - - The Title of our Notification as Growl will show it
    `inDescription` - - The Description of our Notification as Growl will display it
    `inExtraInfo` - - Growl is flexible and allows Display Plugins to do as they please with their own special keys and values, you may use them here. These may be ignored by either the user's preferences or the current Display Plugin. This can be null.
  Throws:
    `java.lang.Exception` - When a notification is not known

### notifyGrowlOf

    public void notifyGrowlOf(java.lang.String inNotificationName,
                              java.lang.String inTitle,
                              java.lang.String inDescription)
                       throws java.lang.Exception

  Convenienve method that defers to notifyGrowlOf(String inNotificationName, NSData inIconData, String inTitle, String inDescription, NSDictionary inExtraInfo) with null passed for icon and extraInfo arguments

  Parameters:
    `inNotificationName` - - The name of one of the notifications we told growl about.
    `inTitle` - - The Title of our Notification as Growl will show it
    `inDescription` - - The Description of our Notification as Growl will display it
  Throws:
    `java.lang.Exception` - When a notification is not known

### notifyGrowlOf

    public void notifyGrowlOf(java.lang.String inNotificationName,
                              java.lang.String inTitle,
                              java.lang.String inDescription,
                              boolean inSticky)
                       throws java.lang.Exception

  Convenience method that defers to notifyGrowlOf(String inNotificationName, NSData inIconData, String inTitle, String inDescription, NSDictionary inExtraInfo, boolean inSticky) with null passed for icon and extraInfo arguments

  Parameters:
    `inNotificationName` - - The name of one of the notifications we told growl about.
    `inTitle` - - The Title of our Notification as Growl will show it
    `inDescription` - - The Description of our Notification as Growl will display it
    `inSticky` - - Whether our notification should be sticky
  Throws:
    `java.lang.Exception` - When a notification is not known

### notifyGrowlOf

    public void notifyGrowlOf(java.lang.String inNotificationName,
                              com.apple.cocoa.application.NSImage inImage,
                              java.lang.String inTitle,
                              java.lang.String inDescription,
                              com.apple.cocoa.foundation.NSDictionary inExtraInfo)
                       throws java.lang.Exception

  Defers to notifyGrowlOf(String inNotificationName, NSData inIconData, String inTitle, String inDescription, NSDictionary inExtraInfo) with null passed for icon and extraInfo arguments

  Parameters:
    `inNotificationName` - - The name of one of the notifications we told growl about.
    `inImage` - - The notification image.
    `inTitle` - - The Title of our Notification as Growl will show it
    `inDescription` - - The Description of our Notification as Growl will display it
    `inExtraInfo` - - Look above for info
  Throws:
    `java.lang.Exception` - When a notification is not known

### notifyGrowlOf

    public void notifyGrowlOf(java.lang.String inNotificationName,
                              java.lang.String inImagePath,
                              java.lang.String inTitle,
                              java.lang.String inDescription)
                       throws java.lang.Exception

  Convenienve method that defers to notifyGrowlOf(String inNotificationName, NSData inIconData, String inTitle, String inDescription, NSDictionary inExtraInfo) with null passed for extraInfo

  Parameters:
    `inNotificationName` - - The name of one of the notifications we told growl about.
    `inImagePath` - - Path to the image for this notification
    `inTitle` - - The Title of our Notification as Growl will show it
    `inDescription` - - The Description of our Notification as Growl will display it
  Throws:
    `java.lang.Exception` - When a notification is not known

### applicationName

    public java.lang.String applicationName()

  Accessor for The currently set "Application" Name

  Returns:
    String - Application Name

### allowedNotifications

    public com.apple.cocoa.foundation.NSArray allowedNotifications()

  Accessor for the Array of allowed Notifications returned an NSArray

  Returns:
    the array of allowed notifications.

### defaultNotifications

    public com.apple.cocoa.foundation.NSArray defaultNotifications()

  Accessor for the Array of default Notifications returned as an NSArray

  Returns:
    the array of default notifications.

### setApplicationName

    public void setApplicationName(java.lang.String inAppName)

  Sets The name of the Application talking to growl

  Parameters:
    `inAppName` - - The Application Name

### setAllowedNotifications

    public void setAllowedNotifications(com.apple.cocoa.foundation.NSArray inAllNotes)

  Set the list of allowed Notifications

  Parameters:
    `inAllNotes` - - The array of allowed Notifications

### setAllowedNotifications

    public void setAllowedNotifications(java.lang.String[] inAllNotes)

  Set the list of allowed Notifications

  Parameters:
    `inAllNotes` - - The array of allowed Notifications

### setDefaultNotifications

    public void setDefaultNotifications(com.apple.cocoa.foundation.NSArray inDefNotes)
                                 throws java.lang.Exception

  Set the list of Default Notfiications

  Parameters:
    `inDefNotes` - - The default Notifications
  Throws:
    `java.lang.Exception` - when an element of the array is not in the allowedNotifications

### setDefaultNotifications

    public void setDefaultNotifications(java.lang.String[] inDefNotes)
                                 throws java.lang.Exception

  Set the list of Default Notfiications

  Parameters:
    `inDefNotes` - - The default Notifications
  Throws:
    `java.lang.Exception` - when an element of the array is not in the allowedNotifications